/* SUGGEST INTERFACE INCLUDE V2.00 FEB 96 */

#ifndef _SUGGESTUSER_H

#ifndef _SYS_TYPES_H
#include <sys/types.h>
#endif

#ifndef _THINGS_H
#include <things.h>
#endif

#define _SUGGESTUSER_H


/* local QL STRING structure
   size of s varies, terminated in null
*/
struct LQLSTR {
        short    l;
        char     s[2];
             };

typedef short DISTTYP;

/* suggestion words are held in this structure
   read only
*/
struct WORD {
        DISTTYP         dist, score;
        struct LQLSTR   s;
                        };


/* array of sorted pointers to words
   read only
*/
struct ARRAY {
        struct WORD     **base;
        int             size;
                                };

/* max dictionary word length */
#define         MAXWORD         128

typedef enum    _ALLTYPE {NONE=0, EXPLICIT=1, IMPLICIT=2} ALLTYPE;

typedef struct _ALLREC ALLREC;
typedef struct _ALL    ALL;

/* public section of globals structure only */
struct GLOBALS {
        void                    *spare;
        short                   root_cut;
        struct ARRAY            wordarray;
        char                    word[MAXWORD];
        chanid_t                spell;
        ALLTYPE                 alltype;
        struct   ALLBUF   {
                     short      l;
                     char       s[MAXWORD];
                           }    allbuf;
        ALLREC                  *allrec;
               };

/* refere to n th most probable word in list as QDOS string */
#define WORD_REF(globals, n)          (globals->wordarray.base[n])

/* a QDOS string */
#define QDOSSTR_REF(globals, n)       (WORD_REF(globals,n)->s)

/* and as C string */
#define CSTRING_REF(globals, n)       (QDOSSTR_REF(globals,n).s)

/* suggest info structure */
struct SUG_INFO {
   char    default_rules[58];
   long    min_stack;
   short   typo_mode;
   short   minword;
   short   explicit_all_only;
   long    default_allsize;
   char    spare[200];
    };



/* suggest thing header -
   executable thing +
   array of entry point vectors
*/
struct SUGGEST_HEAD {
       THING_HEADER_EXEC        head;
       long             (*alloc_global_P)(struct GLOBALS **globals, chanid_t spellch,\
                                struct LQLSTR *jobname, chanid_t owner_con, chanid_t owner,\
                                jobid_t spell_owner);
       long             (*stacklimit_P)(struct GLOBALS *globals, char *limit);
       long             (*infile_P)(struct GLOBALS *globals, char *name, short addrules);
       long             (*killfile_P)(struct GLOBALS *globals);
       long             (*findwords_P)(struct GLOBALS *globals, short newword);
       long             (*freemem_P)(struct GLOBALS *globals);
       struct LQLSTR    *(*find_note_P)(struct WORD *wp);
       struct SUG_INFO  *(*suggest_info_P)(struct SUG_INFO *buf);
       long             (*private_all_P)(ALLREC **allrec);
       long             (*public_all_P)(ALLREC **allrec);
       long             (*clear_all_P)(ALLREC *allrec);
       long             (*save_all_P)(ALLREC *allrec, char *filename);
       long             (*load_all_P)(ALLREC *allrec, char *filename);
       long             (*resize_all_P)(ALLREC *allrec, size_t new_size);
       long             (*addall_P)(ALLREC *allrec, char *for_word, \
                                                char *use, ALLTYPE type);
       long             (*check_all_P)(ALLREC *allrec, struct ALLBUF *buffer, \
                                                char *for_this, ALL **record);
       struct LQLSTR    *(*pull_dn_P)(struct GLOBALS *globals,\
                                                struct LQLSTR *title);
       long             (*cmdpd_P)(struct GLOBALS *globals, void *wman);
                                };

/* suggest extra error messages */

#define  NORULES        "No Rules"
#define  NOWORD         "No Word"
#define  STACKOVER      "Stack Over Flow"
#define  NOTMEMFILE     "Not a History File"
#define  SIZENOTPERM    "Size Not Permitted"

#endif
