/* suggest programmers interface pulldn window example V2.00 Feb 96 */

#include <stdio.h>
#include <qdos.h>
#include <things.h>
#include <string.h>
#include "suggestuser_h"

/* debug stuff */
/*#define  DEBUG*/

#ifdef   DEBUG
#define  D(x, p1, p2)   {fprintf(debug, "%s %d :", __FILE__, __LINE__);\
                         fprintf(debug, x, p1, p2); fflush(debug);}
FILE     *debug;
#else
#define  D(x, p1, p2)
#endif

/* prog macros */
#define  STACKSPC               5000
#define  MINVERS                '2'
#define  VERSINDX(n, v)         (((char *)(&v))[n])
#define  MAX_QDOS_ERROR         (-30)

/* define C68 functionality */
long _stack=STACKSPC;
long (*_cmdchannels)()=NULL;
void (*_consetup)()=NULL;
char _prog_name[]="Pulldn Demo";
char *_endmsg=NULL;

static  struct GLOBALS          *globals;
static  struct SUGGEST_HEAD     *suggest;

/* the entry point to the assembler level window def */
extern  long   pddemo(void);

/* this finds the SUGGEST THING and calls the assembler
   module that sets up the jobs main window
*/
int main(int argc, char *argv[])
{
        chanid_t                spell;
        long                    n, k;
        short                   newword=1, cnt=2;
        struct LQLSTR           *note;
        THING_LINKAGE           *link;
        long                    d2=0, v;
        char                    *a2=NULL;
        char                    *suggest_name="suggest", *spell_name="spell";

        io_close(fgetchid(stdout));
        fclose(stdout);
        fclose(stdin);
        fclose(stderr);

#ifdef  DEBUG
        debug=fopen("ram1_pulldn_log", "w");
#endif

        /* find suggest thing */
        if((long)(suggest=(struct SUGGEST_HEAD *)sms_uthg(suggest_name, \
                -1, -1, &d2, NULL, &v, &link)) < 0)
                        return (int)suggest;

        /* if version too old */
        if(VERSINDX(0, v) < MINVERS)
             return ERR_NI;

        /* open a spell channel, if no dictinary then load */
        if((spell=io_open(spell_name, OLD_SHARE)) < 0)
                if((spell=io_open(spell_name, NEW_EXCL)) < 0)
                        return (int)spell;

        /* allocate suggest global area */
        if((n=(*suggest->alloc_global_P)(&globals, spell, NULL, -1, -1, -1)) < 0)
                return n;

        /* set stack limit */
        if((n=(*suggest->stacklimit_P)(globals, ((char *)&argc) - STACKSPC + 12)) < 0)
                return n;

        return pddemo();
}

/* report console control */
enum info_mode {NORMAL, ERROR, PENDING};

static void set_console(chanid_t console, enum info_mode mode)
{
        int ink, paper;

        switch(mode)
        {
                case NORMAL :   ink=0;
                                paper=7;
                                break;

                case PENDING :  ink=7;
                                paper=0;
                                break;

                case ERROR  :
                default     :
                                ink=0;
                                paper=2;
                                break;
        }

        sd_setsz(console, -1, 0, 0);
        sd_setul(console, -1, 0);
        sd_setin(console, -1, ink);
        sd_setpa(console, -1, paper);
        sd_setst(console, -1, paper);
        sd_setmd(console, -1, 0);
        sd_clear(console, -1);
}

static void write_mess(chanid_t console, char *message)
{
        (void)io_sstrg(console, -1, message, strlen(message));
}

static void set_status(chanid_t console, char *message, enum info_mode mode)
{
        set_console(console, mode);
        write_mess(console, message);
}

static void new_line(chanid_t console)
{
        (void)io_sbyte(console, -1, 10);
}

/* title for SUGGEST Window */
static struct {
       short  l;
       char   s[12];
              }  title={11, "PULLDN DEMO"};

/* effectively the main action activity, this is buffered by some
   assembler code for simplicity.

   The main window channel ID is set to the status info window
   for output.
*/
long    process_word(struct LQLSTR *word, chanid_t win)
{
        long n;
        struct LQLSTR *suggested_word, *note;

        D("Process Word %*s\n", word->l, word->s)
        D("Channel ID %d\n", win, 0)

        /* use SPELL device to parse input string and check spelling */
        n=io_sstrg(globals->spell, -1, word->s, word->l);

        D("Spell returnes %d\n", n, 0)

        if(n >= 0)
        {
             set_status(win, "CORRECT!!", NORMAL);
             return 0;
        }
        else
        {
            if(n < MAX_QDOS_ERROR)
            {
                set_status(win, "CORRECT, word has a note", NORMAL);
                new_line(win);
                note=(struct LQLQSTR *)(n & 0x8fffffff);
                (void)io_sstrg(win, -1, note->s, strchr(note->s, 10) - note->s);

                return 0;
            }
            else
            {
               if(n != ERR_NF)
               {
                   set_status(win, "Error in SPELL write\n", ERROR);
                   return  n;
               }
            }
        }

        /* not known so read it back */
        if((n=io_fstrg(globals->spell, -1, globals->word, MAXWORD - 1)) < 0)
        {
                set_status(win, "Error in SPELL read\n", ERROR);
                return n;
        }

        globals->word[n]=0;

        /* check the history */
        if((globals->alltype=(ALLTYPE)(*suggest->check_all_P)(globals->allrec, \
                        &(globals->allbuf), globals->word, NULL)) > 0)
        {
          D("Had a History\n", 0, 0)

          /* if explicit then display (replace all in an editor) */
          if(globals->alltype == EXPLICIT)
          {
            D("Explicit %*s\n", globals->allbuf.l, globals->allbuf.s)

            set_status(win, "History is ", NORMAL);
            write_mess(win, globals->allbuf.s);
            return 0;
          }
          else
          {
            D("Implicit %*s\n", globals->allbuf.l, globals->allbuf.s)
          }
        }

        D("Calling pulldn\n", 0, 0)

        /* and find suggestions and the user's choice */
        suggested_word=(*suggest->pull_dn_P)(globals, (struct LQLSTR *)&title);

        D("Pulldn returns %d\n", suggested_word, 0)

        /* check for errors and IGNORE/ESC */
        if((long)suggested_word < 0)
        {
           set_status(win, "Error in Pulldn", ERROR);

           D("returning after error trap\n", 0, 0)

           return 0;
        }
        else
        {
           if(suggested_word == NULL)
           {
             set_status(win, "Word Ignored", NORMAL);

             D("returning ignored\n", 0, 0)

             return 0;
           }
           else
           {
             set_status(win, "Word Selected ", NORMAL);
             write_mess(win, suggested_word->s);

             D("returning word selected %s\n", suggested_word->s, 0)

             return 0;
           }
        }
}

/* routine to call the SUGGEST command menu */
long  do_cmd(void *wman)
{
     return (*suggest->cmdpd_P)(globals, wman);
}
